<script lang="ts">
import Vue from 'vue';
import MrktoForm from '~/components/common/form.vue';

export default Vue.extend({
  name: 'FormTabsCard',
  components: {
    MrktoForm,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: () => ({}),
    },
    isAccordion: {
      type: Boolean,
      required: false,
      default: false,
    },
    openByDefault: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      isOpen: this.openByDefault,
    };
  },
  methods: {
    toggleOpen() {
      this.isOpen = !this.isOpen;
    },
    onFormSubmit() {
      this.$emit('submit');
    },
  },
});
</script>

<template>
  <div>
    <article v-if="isAccordion" class="tab-card tab-card-form">
      <button
        class="tab-card__content"
        :aria-expanded="isOpen"
        @click="toggleOpen"
      >
        <div class="tab-card__header">
          <SlpTypography tag="h4" variant="body1-bold">
            {{ data.title }}
          </SlpTypography>
        </div>
        <div class="tab-card__content--text">
          <div v-html="$md.render(data.text)" />
          <SlpIcon
            v-if="isOpen"
            name="dash"
            variant="product"
            alt=""
            size="sm"
          />
          <SlpIcon v-else name="plus" variant="product" alt="" size="sm" />
        </div>
      </button>
      <div v-show="isOpen" class="form-wrapper">
        <div
          class="form-wrapper__blurb"
          v-html="$md.render(data.form.blurb)"
        ></div>
        <MrktoForm
          :data="data.form"
          class="form-wrapper__form"
          @submit="onFormSubmit"
        />
      </div>
    </article>
    <article v-else class="tab-card">
      <a
        :href="data.link"
        :data-ga-name="data.dataGaName"
        :data-ga-location="data.dataGaLocation"
        class="tab-card__content"
      >
        <div class="tab-card__header">
          <SlpTypography tag="h4" variant="body1-bold">
            {{ data.title }}
          </SlpTypography>
        </div>
        <div class="tab-card__content--text">
          <client-only>
            <div v-html="$md.render(data.text)"></div>
          </client-only>
        </div>
      </a>
    </article>
  </div>
</template>

<style lang="scss" scoped>
.tab-card {
  background: linear-gradient(
    96deg,
    rgba(225, 152, 109, 0.1) -2.37%,
    rgba(110, 67, 211, 0.1) 102.1%
  );
  border-radius: 8px;
  padding: $spacing-16 $spacing-24;
  &__header {
    font-weight: $font-weight-bold;
    padding-bottom: $spacing-8;
  }
  border: 1px solid $color-surface-600;

  &:hover {
    background: linear-gradient(
      96deg,
      rgba(225, 152, 109, 0.25) -2.37%,
      rgba(110, 67, 211, 0.25) 102.1%
    );
    cursor: pointer;
  }

  button {
    cursor: pointer;
  }

  &__content {
    border-radius: 0 0 8px 8px;
    border: 1px solid $color-surface-100;
    border-top: none;
    padding: 0;
    text-align: left;
    font-size: 16px;
    line-height: 24px;
    border: none;
    color: $color-text-50;

    &--text {
      flex: 0 1 80%;
      display: flex;
      align-items: center;
      justify-content: space-between;
      &:deep(p) {
        margin-bottom: 8px;
      }

      @media (max-width: $breakpoint-md) {
        flex: 0 1 85%;
      }
    }
    &:deep {
      a,
      .link {
        font-weight: $font-weight-bold;
        color: $color-accent-400;
        &:hover {
          text-decoration: underline;
        }
      }
    }
  }

  .form-wrapper {
    padding-top: $spacing-24;
    &__blurb {
      :deep {
        .header-anchor {
          display: none;
        }
        p {
          margin: $spacing-8 0;
          font-size: 14px;
        }
        a {
          color: $color-accent-400;
        }
        blockquote {
          color: $color-surface-500;
          font-family: 'GitLab Sans';
          font-size: 14px;
          font-style: italic;
          font-weight: 400;
          line-height: 20px;
          margin-bottom: 24px;
        }
        sup {
          font-size: 20px;
          font-style: normal;
          font-weight: 600;
          line-height: 24px;
        }
        h3 {
          font-size: 24px;
          line-height: 32px;
        }
      }
    }
    :deep {
      .form_column .form_container {
        padding: 0 !important;
        border: none !important;
        background: none !important;
        color: $color-text-50 !important;
      }

      .mktoForm .mktoRequiredField label.mktoLabel,
      .mktoForm_container .mktoFieldWrap label.mktoLabel,
      .mktoErrorMsg,
      .mktoHtmlText,
      .mktoForm_container
        .mktoLogicalField.mktoCheckboxList.mktoHasWidth
        label {
        color: $color-text-50 !important;
        padding-left: 0 !important;
      }

      .slp-px-md-32 {
        padding: 0 !important;
      }

      .mktoForm_container a:not(.btn):not(.slp-btn) {
        color: $color-accent-400 !important;
      }

      .mktoButtonRow .mktoButtonWrap button {
        max-width: 180px;
        margin-bottom: 0;
        background-color: $color-surface-50 !important;
        color: $color-text-300 !important;

        &:hover {
          background-color: $color-surface-200 !important;
        }
      }

      .mktoForm fieldset legend,
      .mktoForm fieldset {
        display: none;
      }

      #InstructgitLabSubscriptionName,
      #InstructEmail {
        display: block;
        margin-bottom: 8px;
        color: $color-text-50 !important;
      }
    }
  }
}

.tab-card-form {
  padding: 0;

  .tab-card__header {
    padding: $spacing-16 0 $spacing-8 0;
  }
  .tab-card__content {
    padding: 0 $spacing-24 $spacing-16 $spacing-24;
  }

  .form-wrapper {
    background: $color-surface-700;
    padding: $spacing-24;
    border-radius: 0 0 8px 8px;
  }
}
</style>
